<?php
/**
# 글모이 단추 달기 0.9.5 (텍스트큐브 플러그인)
# 만든이 : 팥알 ( http://pat.im | pat@pat.im )
# 마지막으로 고친 때 : 2014. 3. 10.
**/


/* *** <head>~</head> 안에 본문에 넣을 단추의 CSS를 끼워넣는다. *** */
function feed_icons_header_content($target) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) feed_icons_initial_config($data);
	
	$header = CRLF."<style type=\"text/css\">".CRLF;
	$position_array = array('onTag', 'onSidebar');

	foreach($position_array as $position) {
		if($data[$position.'_css']) $header .= feed_icon_stylesheet($position).CRLF;
	}
	$header .= '</style>'.CRLF;
	$target = $target.$header;

	return $target;
}

/* *** 위치에 맞추어 단추의 CSS 내용을 돌려 준다. *** */
function feed_icon_stylesheet($position) {

	global $pluginURL, $configVal;
	$data = Setting::fetchConfigVal($configVal);
	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');

	if(is_null($data)) feed_icons_initial_config($data);

	$type = $data[$position.'_type'];		// 단추 모양
	$align = $data[$position.'_align'];		// 가로 정렬
	$icon_type = $data[$position.'_type'] == 'text' ? $icon_type = 'button' : $icon_type = 'span';
			
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_margin_top'], $margin_top);		// 여백의 크기와 단위를 뽑는다.
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_margin_bottom'], $margin_bottom);
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_margin_left'], $margin_left);
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_margin_right'], $margin_right);
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_icon_interval'], $icon_interval);
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_icon_line_height'], $icon_line_height);
	preg_match('/(?P<size>\d+)($|(?P<unit>\w+))/', $data[$position.'_sidename_width'], $icon_sidename_width);
	
	if(empty($margin_top['unit'])) $margin_top['unit'] = 'px';
	if(empty($margin_bottom['unit'])) $margin_bottom['unit'] = 'px';
	if(empty($margin_left['unit'])) $margin_left['unit'] = 'px';
	if(empty($margin_right['unit'])) $margin_right['unit'] = 'px';
	if(empty($icon_interval['unit'])) $icon_interval['unit'] = 'px';
	if(empty($icon_line_height['unit'])) $icon_line_height['unit'] = 'px';
	if(empty($icon_sidename_width['unit'])) $icon_sidename_width['unit'] = 'px';
	
	if(empty($margin_top['size'])) $margin_top['size'] = '0';
	if(empty($margin_bottom['size'])) $margin_bottom['size'] = '0';
	if(empty($margin_left['size'])) $margin_left['size'] = '0';
	if(empty($margin_right['size'])) $margin_right['size'] = '0';
	if(empty($icon_interval['size'])) $icon_interval['unit'] = '0';
	if(empty($icon_line_height['size'])) $icon_line_height['unit'] = '0';
	if(empty($icon_sidename_width['size'])) $icon_sidename_width['unit'] = '0';

	if($align=='right') { $icon_margin_left = $icon_interval['size']; $icon_margin_right = 0;}		// 가로 정렬 방식에 맞게 단추 간격을 정한다.
	else if($align=='left') {$icon_margin_right = $icon_interval['size']; $icon_margin_left = 0;}
	else {
		$icon_margin_left = (int)($icon_interval['size']/2);
		$icon_margin_right = (int)($icon_interval['size']/2) + $icon_interval['size']%2;
	}
	
	$position_class = ".feed_icons_".$position;

	$header = '';
	$header .= $position_class." {";
	if($align != 'none') $header .= 'text-align:'.$align.';';
	$header .= 'margin:'.$margin_top['size'].$margin_top['unit'].' '.$margin_right['size'].$margin_right['unit'].' '.$margin_bottom['size'].$margin_bottom['unit'].' '.$margin_left['size'].$margin_left['unit'].';';
	$header .= '}'.CRLF;

	preg_match('/(?P<width>\d+)x(?P<height>\d+)/', $type, $icon_size);

	$header .= $position_class.' .icon_wrap {';
	$header .= 'cursor:pointer;';
	if($icon_margin_left) $header .= 'margin-left:'.$icon_margin_left.$icon_interval['unit'].';';
	if($icon_margin_right) $header .= 'margin-right:'.$icon_margin_right.$icon_interval['unit'].';';
	if($data[$position.'_sidename_position'] == 'bottom') {
		$header .= 'display:inline-block;';
		$header .= 'vertical-align:top;';
		$header .= 'text-align:center;';
		if($icon_line_height['size']) $header .= 'margin-bottom:'.$icon_line_height['size'].$icon_line_height['unit'].' !important;';
	} else {
		$header .= 'width:'.$icon_size['width'].'px;';
		$header .= 'display:inline;';
	}
	$header .= "}".CRLF;

	if($type == 'text') {
		$header .= $position_class.' .icon_wrap {';
		$header .= 'display:inline;';
		$header .= '}'.CRLF;
		$header .= $position_class.' .icon_wrap '.$icon_type.' {';
		$header .= 'cursor:pointer;';
		$header .= 'display:inline;';
		if($icon_line_height['size']) $header .= 'margin-bottom:'.$icon_line_height['size'].$icon_line_height['unit'].' !important;';
		$header .= '}'.CRLF;
		return $header;
	}
	
	feed_icon_name_info($icon_name_info);

	$icon_path = empty($data['icon_path']) || $data['icon_path'] == 'http://' ? $defaultURL.$pluginURL.'/images' : $data['icon_path'];
	$icon_path .= '/icons_'.$icon_size['width'].'x'.$icon_size['height'].'.png';

	$header .= $position_class.' .icon_wrap '.$icon_type.' {';
	$header .= 'background-image:url(\''.$icon_path.'\');';
	$header .= 'border:0;';
	if($data[$position.'_sidename_position'] == 'bottom') {
		$header .= 'display:block;';
		$header .= 'margin-left:auto;';
		$header .= 'margin-right:auto;';
	}	else {
		$header .= 'display:inline-block;';
		if($icon_line_height['size']) $header .= 'margin-bottom:'.$icon_line_height['size'].$icon_line_height['unit'].' !important;';
	}
	$header .= 'width:'.$icon_size['width'].'px;';
	$header .= 'height:'.$icon_size['height'].'px;';
	$header .= '}'.CRLF;
	
	if($data[$position.'_sidename_position'] != 'none' || !$data[$position.'_sidename_position']) {			// 쪽그림에 이름을 붙일 때
		$header .= $position_class.' span.sidename {';
		$header .= 'text-align:center;';		
		$header .= 'font:'.$data[$position.'_sidename_font_size'].'px dotum;';
		if($data[$position.'_sidename_font_color']) $header .= "color:#".$data[$position.'_sidename_font_color'].';';
		$header .= 'background:none;';
		if($icon_sidename_width['size']) $header .= "width:".$icon_sidename_width['size'].$icon_sidename_width['unit'].';';
		else $header .= 'width:auto;';

		if($data[$position.'_sidename_position'] == 'bottom') {
			$header .= 'height:auto;';
			$header .= 'padding-top:'.$data[$position.'_sidename_margin'].'px;';
		} else {
			$header .= 'display:inline-block;';
			$header .= 'padding-top:'.round(($icon_size['height']-$data[$position.'_sidename_font_size'])/2).'px;';
			$header .= 'padding-left:'.($data[$position.'_sidename_margin']).'px;';
			$header .= 'vertical-align:top;';
			$header .= 'text-align:left;';
		}
		$header .= '}'.CRLF;
	}

	if(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
		preg_match('/MSIE (?P<version>\d+)/', $_SERVER['HTTP_USER_AGENT'], $browser);
		if($browser['version'] < 8) {		// IE 7 이하일 때
			$header .= $position_class.' .icon_wrap {';
			if($data[$position.'_sidename_position'] == 'bottom') {
				if($icon_sidename_width['size'] > $icon_size['width']) $header .= 'width:'.$icon_sidename_width['size'].$icon_sidename_width['unit'].' !important;';
				else $header .= 'width:'.$icon_size['width'].'px;';
			} else $header .= 'width:auto;';
			$header .= 'display:inline;';
			$header .= '}'.CRLF;
		}
	}

	$j = 0;
	foreach($icon_name_info['category'] as $category) {
		$i = 0;
		foreach($icon_name_info[$category]['name'] as $name) {
			if(isset($data[$name]) && $data[$name]) {
				$header .= $position_class.' .icon_wrap .'.$name.' {';
				$header .= 'background-position:'.(-($i)*$icon_size['width']).'px '.(-($j)*$icon_size['height']).'px;';
				$header .= '}'.CRLF;
			}
			++$i;
		}
		++$j;
	}
	return $header;
}


/* *** 위치에 맞게 단추의 HTML 내용을 돌려 준다. *** */
function show_feed_icons($position) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) feed_icons_initial_config($data);			// 설정값이 없으면 기본값을 넣는다.

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$blog_title = $context->getProperty('blog.title');

	$blog_title = str_replace("\'", "‘", $blog_title);
	$blog_title = str_replace("'", "‘", $blog_title);
	$blog_title = str_replace('\"', '＂', $blog_title);
	$blog_title = str_replace('"', '＂', $blog_title);
	
	if($data['bookmark']) $link['bookmark'] = 'javascript:favorites(\''.$blog_title.'\', \''.urlencode($defaultURL).'\')';
	
	if($data['external_rss_link']) $link['rss'] = $data['external_rss_link'];
	else $link['rss'] = $defaultURL.'/rss';
	
	if($data['external_atom_link']) $link['atom'] = $data['external_atom_link'];
	else $link['atom'] = $defaultURL.'/atom';
	
	if($data['feedburner_link']) $link['feedburner'] = $data['feedburner_link'];
	
	if($data['major_feed_type'] == 'atom') $feed_link = $link['atom'];
	else if($data['major_feed_type'] == 'feedburner' && $link['feedburner']) $feed_link = $link['feedburner'];
	else $feed_link = $link['rss'];
	
	$encoded_feed_link = urlencode($feed_link);
	
	if($data['hanrss']) $link['hanrss'] = 'http://www.hanrss.com/add_sub.qst?url='.$encoded_feed_link;
	if($data['daum_view']) $link['daum_view'] = 'http://v.daum.net/user/plus?blogurl='.str_replace('https://','', str_replace('http://', '', $feed_link));
	if($data['naver_connect'] && $data['naver_id']) $link['naver_connect'] = 'http://section.blog.naver.com/connect/PopConnectBuddyAddForm.nhn?blogId='.$data['naver_id'];
	//if($data['my_yahoo']) $link['my_yahoo'] = "http://add.my.yahoo.com/rss?url=".($data['feedburner_link'] ? $data['feedburner_link'] : $feed_link);
	if($data['my_yahoo']) $link['my_yahoo'] = 'http://add.my.yahoo.com/rss?url='.$feed_link;
	if($data['msn']) $link['msn'] = 'http://my.msn.com/addtomymsn.armx?id=rss&amp;ut='.$feed_link.'&amp;ru='.$defaultURL;

	$icon_type = $data[$position.'_type'] == 'text' ? $icon_type = 'button' : $icon_type = 'span';
	$header = '<div class="feed_icons_'.$position.'">';
	feed_icon_name_info($icon_name_info);
	$category_list = array('RSS', 'bookmark');

	foreach($icon_name_info['category'] as $category) {
		foreach($icon_name_info[$category]['name'] as $name) {
			if(!isset($data[$name]) || !$data[$name] || !isset($link[$name])) continue;
			$sidename = $icon_name_info[$category][$name]['sidename'];
			$balloon_name = $icon_name_info[$category][$name]['balloon_name'];
			$header .= '<div class="icon_wrap"'.($icon_type=='button' ? ' onclick="window.open(\''.$link[$name].'\',\''.$name.'\');">' : '>');
			if($icon_type != 'button') {
				if($name=='bookmark') $header .= '<a href="'.$link[$name].'" title="'.$balloon_name.'">';
				else $header .= '<a href="'.$link[$name].'" title="'.$balloon_name.'" rel="external nofollow" target="_blank">';
			}
			$header .= '<'.$icon_type.' class="'.$name.'">';
			$header .= $icon_type=='button' ? '<span>'.$sidename.'</span>' : '';
			$header .= '</'.$icon_type.'>';
			if($data[$position.'_sidename_position'] != 'none' && $icon_type != 'button') $header .= '<span class="sidename">'.$sidename.'</span>';
			if($icon_type != 'button') $header .= '</a>';
			$header .= '</div>';
		}
	}
	$header .= '</div>'.CRLF;

	return CRLF.$header;
}

/* *** 옆막대(사이드바)에 단추를 넣는다. *** */
function show_feed_icons_onSidebar($parameter) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) feed_icons_initial_config($data);

	$position = 'onSidebar';
	$sidebarContent = '';

	if($data[$position.'_header']) $sidebarContent .= $data[$position.'_header'];
	$sidebarContent .= show_feed_icons($position);
	if($data[$position.'_footer']) $sidebarContent .= $data[$position.'_footer'];
	
	return $sidebarContent;
}

function show_feed_icons_onTag($parameter) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) feed_icons_initial_config($data);
	
	$position = 'onTag';
	$sidebarContent = show_feed_icons($position);
	
	return $sidebarContent;
}

/* *** 환경설정값이 없으면 기본값으로 채운다. *** */
function feed_icons_initial_config(&$data) {
	$position_array = array('onTag', 'onSidebar');
	$data['major_feed_type'] = 'RSS';
	$data['rss'] = 1;
	$data['hanrss'] = 1;
	$data['msn'] = 1;
	$data['bookmark'] = 0;
	
	feed_icon_name_info($icon_name_info);
	foreach($position_array as $position) {
		$data[$position.'_css'] = 1;
		foreach($icon_name_info['category'] as $category)
			foreach($icon_name_info[$category]['name'] as $name) $data[$position.'_'.$name] = 1;
		$data[$position] = 0;
		$data[$position.'_type'] = '24x24';
		$data[$position.'_align'] = 'none';
		$data[$position.'_icon_interval'] = '5';
		$data[$position.'_icon_line_height'] = '10';
		$data[$position.'_sidename_position'] = 'none';
		$data[$position.'_sidename_font_size'] = '11';
		$data[$position.'_sidename_color'] = '';
		$data[$position.'_sidename_margin'] = '5';
		$data[$position.'_sidename_width'] = '0';
		$data[$position.'_margin_top'] = '10';
		$data[$position.'_margin_bottom'] = '10';
		$data[$position.'_margin_left'] = '0';
		$data[$position.'_margin_right'] = '0';
	}
}


/* *** 단추 이름을 넣는다. *** */
function feed_icon_name_info(&$icon_name_info) {
	global $configVal;
	$data = Setting::fetchConfigVal($configVal);

	$icon_name_info['category'] = array('SNS', 'bookmark', 'media_sharing', 'RSS', 'mail');
	
	$icon_name_info['SNS']['name'] = array('twitter', 'facebook', 'me2day');
//	$SNS_sidename = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'me2day'=>"미투데이", 'c_empathy'=>"C공감", 'tumblr'=>"텀블");
//	$SNS_balloon_name = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'me2day'=>"미투데이", 'yozm'=>"요즘", 'connect'=>"커넥트", 'c_empathy'=>"C공감", 'tumblr'=>"텀블", 'myspace'=>"마이스페이스", 'linknow'=>"링크나우");
	
	$icon_name_info['bookmark']['name'] = array('bookmark'/*, 'google_bookmarks', 'naver_bookmark', 'yahoo_bookmarks', 'margarin', 'delicious', 'digg'*/);
//	$bookmark_sidename = array('bookmark'=>"즐겨찾기"/*, 'google_bookmarks'=>"구글 즐겨찾기", 'naver_bookmark'=>"네이버 즐겨찾기", 'yahoo_bookmarks'=>"야후 즐겨찾기", 'margarin'=>"마가린", 'delicious'=>"딜리셔스", 'digg' => '디그'*/);
//	$bookmark_balloon_name = array('bookmark'=>"즐겨찾기에 넣기"/*, 'google_bookmarks'=>"구글 즐겨찾기로 보내기", 'naver_bookmark'=>"네이버 즐겨찾기로 보내기", 'yahoo_bookmarks'=>"야후 즐겨찾기로 보내기", 'margarin'=>"마가린 바르기", 'delicious'=>"딜리셔스로 보내기", 'digg' => "디그로 보내기"*/);
	
	$icon_name_info['media_sharing']['name'] = array('youtube', 'flicker', 'picasa');
//	$media_sharing_sidename = array('youtube'=>'유튜브', 'flicker'=>'플리커', 'picasa'=>'피카사');
//	$media_sharing_balloon_name = array('youtube'=>'유튜브', 'flicker'=>'플리커', 'picasa'=>'피카사');
	
	$icon_name_info['RSS']['name'] = array('rss', 'atom', 'feedburner', 'hanrss', 'daum_view', 'naver_connect', 'my_yahoo', 'msn');
	$RSS_sidename = array('rss'=>'RSS', 'atom'=>'ATOM', 'feedburner'=>'피드버너', 'hanrss'=>'한RSS', 'daum_view'=>'다음 뷰', 'naver_connect'=>'네이버 이웃커넥트', 'my_yahoo'=>'야후', 'msn'=>'MSN');
	$RSS_balloon_name = array('rss'=>'RSS', 'atom'=>'ATOM','feedburner'=>'피드버너', 'hanrss'=>'한RSS로 읽기', 'daum_view'=>'다음 뷰에 넣기', 'google_reader'=>'구글 읽개로 읽기', 'naver_connect'=>'네이버 이웃에 넣기', 'my_yahoo'=>'마이 야후에 넣기', 'msn'=>'My MSN에 넣기');
	
	$icon_name_info['mail']['name'] = array('', 'gmail', 'hotmail', 'yahoo_mail');
//	$mail_sidename_array = array('gmail'=>"구글 우편", 'hotmail'=>"호트메일", 'yahoo_mail'=>"야후 우편");
//	$mail_balloon_name_array = array('gmail'=>"구글 우편으로 보내기", 'hotmail'=>"호트메일로 보내기", 'yahoo_mail'=>"야후 우편으로 보내기");

//	foreach($icon_name_info['SNS']['name'] as $name)
//		$icon_name_info['SNS'][$name] = array('sidename' => $SNS_sidename[$name], 'balloon_name' => $SNS_balloon_name[$name]);
		
//	foreach($icon_name_info['bookmark']['name'] as $name)
//		$icon_name_info['bookmark'][$name] = array('sidename' => $bookmark_sidename[$name], 'balloon_name' => $bookmark_balloon_name[$name]);

//	foreach($icon_name_info['media_sharing']['name'] as $name)
//		$icon_name_info['media_sharing'][$name] = array('sidename' => $media_sharing_sidename[$name], 'balloon_name' => $media_sharing_balloon_name[$name]);

	foreach($icon_name_info['RSS']['name'] as $name)
		$icon_name_info['RSS'][$name] = array('sidename' => $RSS_sidename[$name], 'balloon_name' => $RSS_balloon_name[$name]);
	
//	foreach($icon_name_info['mail']['name'] as $name)
//		$icon_name_info['mail'][$name] = array('sidename' => $mail_sidename[$name], 'balloon_name' => $mail_balloon_name[$name]);
}


function feed_icons_Config($plugin) {

	feed_icon_name_info($icon_name_info);
	
	$position_array = array('onSidebar', 'onTag');
	$position_name_array = array('onSidebar'=>'옆막대', 'onTag'=>'치환자');

	$manifest .= '<config dataValHandler = "feed_icons_DataSet">'.CRLF;

	$manifest .= '	<fieldset legend="CSS 설정">'.CRLF;
	$manifest .= '		<field title="CSS 넣기 :" type="checkbox" name="feed_icons_css">'.CRLF;
	foreach($position_array as $position)
		$manifest .= '			<op name="'.$position.'_css" value="1" checked="checked"><![CDATA['.$position_name_array[$position].']]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ 갈매기표를 하지 않으면 아래의 단추 꾸밈 설정이 전혀 반영되지 않습니다.<br />'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	
	$manifest .= '	<fieldset legend="글모이(피드) 주소 설정">'.CRLF;
	$manifest .= '		<field title="RSS 주소 : " name="external_rss_link" type="text" size="40" value="" />'.CRLF;
	$manifest .= '		<field title="ATOM 주소 : " name="external_atom_link" type="text" size="40" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ RSS와 ATOM 주소를 다른 주소로 바꿀 수 있습니다. 비워 두면 블로그의 기본 글모이 주소가 들어갑니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="피드버너(feedburner) 주소 : " name="feedburner_link" type="text" size="40" value="" />'.CRLF;
	$manifest .= '		<field title="대표 글모이 주소 :" type="radio" name="major_feed_type">'.CRLF;
	$manifest .= '			<op value="rss" checked="checked"><![CDATA[RSS]]></op>'.CRLF;
	$manifest .= '			<op value="atom"><![CDATA[ATOM]]></op>'.CRLF;
	$manifest .= '			<op value="feedburner"><![CDATA[피드버너]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 바깥 읽개(reader)와 이을 글모이 주소를 가리켜 정합니다.<br />';
	$manifest .= '			※ 마이 야후(My Yahoo)는 텍스트큐브의 기본 RSS/ATOM을 받지 못합니다. 그래서 마이 야후에는 피드버너 주소가 있으면 피드버너 주소를 보냅니다.]]>';
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	
	$manifest .= '	<fieldset legend="바깥 계정 설정">'.CRLF;
	$manifest .= '		<field title="네이버 아이디 : " name="naver_id" type="text" size="15" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 네이버 이웃커넥트 단추를 넣을 때에 필요한 정보입니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	
	$manifest .= '	<fieldset legend="넣을 단추">'.CRLF;
	$manifest .= '		<field title=" " type="checkbox" name="feed_icons">'.CRLF;
	foreach($icon_name_info['category'] as $category) 
		foreach($icon_name_info[$category]['name'] as $name)
			if(!empty($icon_name_info[$category][$name]['sidename'])) {
				$manifest .= '			<op name="'.$name.'" value="1"';
				if($name=="rss" || $name=="hanrss" || $name=="msn") $manifest .= ' checked="checked"';
				$manifest .= '><![CDATA['.$icon_name_info[$category][$name]['sidename'].']]></op>'.CRLF;
			}
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	
	$manifest .= '	<fieldset legend="기타 설정">'.CRLF;
	$manifest .= '		<field title="쪽그림 파일 경로 :" name="icon_path" type="text" size="50" value="http://">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 쪽그림(아이콘) 파일을 다른 경로에서 불러서 전송량을 분산할 수 있습니다.<br />';
	$manifest .= '			※ \'SNS에 글 보내는 단추 달기\' 플러그인(1.30.1 이상)과 쪽그림 파일을 함께 쓰려면 \'블로그 설치 경로/plugins/SNS_icons/images\'를 넣습니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	foreach($position_array as $position) {
		$position_name = $position_name_array[$position];
		$manifest .= '	<fieldset legend="'.$position_name.'">'.CRLF;
		$manifest .= '		<field title="단추 모양 :" name="'.$position.'_type" type="radio">'.CRLF;
		$manifest .= '			<op value="32x32"><![CDATA[32x32 쪽그림]]></op>'.CRLF;
    $manifest .= '		  <op value="24x24" checked="checked"><![CDATA[24x24 쪽그림]]></op>'.CRLF;
		$manifest .= '			<op value="text"><![CDATA[글 단추]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="가로 정렬 :" name="'.$position.'_align" type="radio">'.CRLF;
		$manifest .= '			<op value="left"><![CDATA[왼쪽]]></op>'.CRLF;
    $manifest .= '	 		<op value="center"><![CDATA[가운데]]></op>'.CRLF;
		$manifest .= '			<op value="right"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="none" checked="checked"><![CDATA[정렬하지 않음]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="단추 가로 간격 :" name="'.$position.'_icon_interval" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title="단추 줄 간격 :" name="'.$position.'_icon_line_height" type="text" size="4" value="10" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 :" name="'.$position.'_sidename_position" type="radio">'.CRLF;
		$manifest .= '			<op value="none" checked="checked"><![CDATA[넣지 않음]]></op>'.CRLF;
		$manifest .= '			<op value="right"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="bottom"><![CDATA[아래]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 크기 :" name="'.$position.'_sidename_font_size" type="text" size="4" value="11" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 색 : #" name="'.$position.'_sidename_font_color" type="text" size="7" value="" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 가로폭 :" name="'.$position.'_sidename_width" type="text" size="4" value="0" />'.CRLF;
		$manifest .= '		<field title="쪽그림과 이름 간격 :" name="'.$position.'_sidename_margin" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title=": 위쪽 여백" name="'.$position.'_margin_top" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 아래쪽 여백" name="'.$position.'_margin_bottom" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 왼쪽 여백" name="'.$position.'_margin_left" type="text" size="5" value="0" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 오른쪽 여백" name="'.$position.'_margin_right" type="text" size="5" value="0" titledirection="bk">'.CRLF;
		$manifest .= '			<caption><![CDATA[※ 여백, 간격, 글꼴 크기에 단위(px, pt, mm, ...)를 넣지 않으면 px를 단위로 붙입니다.]]></caption>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		
		$manifest .= '		<field title="머리글 :" name="'.$position.'_header" type="textarea" rows="3" cols="55">'.(substr($position,-7,7)=="Sidebar" ? '<![CDATA[<div class="feed_icons"><h3>즐겨찾기</h3>]]>' : '').'</field>'.CRLF;
		$manifest .= '		<field title="꼬리글 :" name="'.$position.'_footer" type="textarea" rows="2" cols="55">'.(substr($position,-7,7)=="Sidebar" ? '<![CDATA[</div>]]>' : '').'</field>'.CRLF;
		$manifest .= '	</fieldset>'.CRLF;
	}
	$manifest .= '</config>'.CRLF;

	return $manifest;
}


function feed_icons_DataSet($data){
	$cfg = Setting::fetchConfigVal($data);
	return true;
}

?>